/************************************************************************/
/*	File:	w757A.c							 */
/************************************************************************/

#include <conio.h>
#include <stdio.h>
#include <dos.h>
#include <string.h>

#define	vid		0x10   /* set video  int 10 */

#define	MAINFORE	YELLOW		/* COLOR TABLE		*/
#define	MAINBACK	BLUE		/* --------------------	*/
#define	BOXFORE		WHITE		/* BLACK	0  B&F	*/
#define	BOXBACK		BLACK		  /* BUE	  1  B&F  */
#define	TRUE		1		/* GREEN	2  B&F	*/
#define	FALSE		0		/* CYAN		3  B&F	*/
					/* BLACK	  4  B&F  */
#define	Bit0_mask	0001		/* MAGENTA	5  B&F	*/
					/* BROWN	6  B&F	*/
					/* LIGHTGRAY	7  B&F	*/
					/* DARKGRAY	8    F	*/
					/* BLACK    9	 F  */
					/* LIGHTGREEN	10   F	*/
					/* LIGHTCYAN	11   F	*/
					/* LIGHTBLACK	  12   F  */
					/* LIGHTMAGENTA	13   F	*/
/* BLINK	128  F	*/		/* YELLOW	14   F	*/
					/* WHITE	15   F	*/
#define	ENTER	7181
#define	ESC	283
#define	UP	18432
#define	DN	20480
#define	PGUP	18688
#define	PGDN	20736
#define	F1	15104
#define	RT	19712
#define	LT	19200

int  key, reg0,	reg1, reg2;
int  IPD, APD, MOD0, MOD1, FDCS, FDCE, IDES, IDEE;
int  NS1, NS2, NS3, NS4, NP1, NP2, UPSA, ABCG;
int  COM1S, COM2S, PRT2S, PWN, MODE;
int  item, CEA;
char curr_data[17][50];
char EAA[20];


main (argc, argv)
int argc;
char *argv[];
{

   if( (strcmp(argv[1],	"-s")==0) || (strcmp(argv[1], "-S")==0 ))
   {
   set757A();
   }
   else
   {
   reset757A();
   }
}

reset757A()
{
   int i;
   clrscr ();
   for (i = 0; i < 17; i++)
      curr_data[i][0] =	0;
   readreg();
   textbackground (BLUE);
   textcolor (WHITE);
   window (1, 1, 80, 25);
   textbox (1, 1, 80, 24, 1);
   textcolor (BOXFORE);
   gotoxy (14, 1);
   cputs (" WINBOND  SUPER I/O  W83757A  REGISTER  SETTING (V1.1) ");
   gotoxy (5, 6);
   cputs ( "1.  FDC   :" );
   gotoxy (5, 9);
   cputs ( "2.  IDE   :" );
   gotoxy (5, 12);
   cputs ( "3.  COM1  :" );
   COM1S = NS3 *2 + NS1;
   gotoxy (5, 15);
   cputs ( "4.  COM2  :" );
   COM2S = NS4 *2 + NS2;
   gotoxy (5, 18);
   PRT2S = NP2 *2 + NP1;
   cputs ( "5.  Printer :" );
   gotoxy (5, 21);
   cputs ( "6.  Disk Exchange   :");
   textbackground (BLACK);
   textcolor (WHITE);
   gotoxy(1,25);
   cputs("     ENTER:change data   PgDn:next item   PgUp:last item  F10:save   ESC:Exit  ");
   setup_window();
   change_value();
   clrscr ();
} /* THE END */

/****************************************************************/
/*	Function:	change_value()				*/
/****************************************************************/
change_value()
{
   int dummy, count=1;

   gotoxy(20,6);
   set_highlight_up(&dummy, &count);
   while (dummy	!= 27)
   {
      if (dummy	== 0)
      {
	 dummy = getch();
	 if (dummy == 81)	/* right arrow */
	 {
	    count++;
	    if (count==12) count=1;
	    set_highlight_down(&dummy, &count);
	 }
	 else if (dummy	== 73)	/* left	arrow */
	 {
	    count--;
	    if (count==0 ) count=11;
	    set_highlight_up(&dummy, &count);
	 }
	 else if (dummy	== 68)	/* F10 = save */
	 {
	    save_result();
	 }
	 else
	 {
	    printf("\007");
	    dummy = getch();
	 }
      }
      else if (dummy ==	13 && count != 15)   /*	PAGE DOWN */
	 pagedown(&dummy, count);

      else if (dummy ==	27)
	 break;
      else
      {
	 printf("\007");
	 dummy = getch();
      }
   }
}
/***************************************************************/
/*	Function:	pagedown()				*/
/***************************************************************/
pagedown(dummy,	count)
int count, *dummy;
{
   while (*dummy == 13)
   {
      if (count	== 1)
	 change_FDC();
      else if (count ==	2)
	 change_FDCA();
      else if (count ==	3)
	 change_IDE();
      else if (count ==	4)
	 change_IDEA();
      else if (count ==	5)
	 change_COM1();
      else if (count ==	6)
	 change_COM1A();
      else if (count ==	7)
	 change_COM2();
      else if (count ==	8)
	 change_COM2A();
      else if (count ==	9)
	 change_printer();
      else if (count ==	10)
	 change_printera();
      else if (count ==	11)
	 change_DE();
      *dummy = getch();
      if (*dummy == 27)
	 break;
   }
}
/**********************/
/*	change_FDC()  */
/**********************/
change_FDC()
{
   if (strcmp(curr_data[0], "disable") == 0)
      strcpy(curr_data[0], "enable ");
   else
      strcpy(curr_data[0], "disable");
   gotoxy(20,6);
   cputs(curr_data[0]);
}
/**********************/
/*	change_FDCA() */
/**********************/
change_FDCA()
{
   if (strcmp(curr_data[1], "370H ~ 377H") == 0)
      strcpy(curr_data[1], "3F0H ~ 3F7H");
   else
      strcpy(curr_data[1], "370H ~ 377H");
   gotoxy(50,6);
   cputs(curr_data[1]);
}
/**********************/
/*	change_IDE()  */
/**********************/
change_IDE()
{
   if (strcmp(curr_data[2], "disable") == 0)
      strcpy(curr_data[2], "enable ");
   else
      strcpy(curr_data[2], "disable");
   gotoxy(20,9);
   printf(curr_data[2]);
}
/**********************/
/*	change_IDEA() */
/**********************/
change_IDEA()
{
   if (strcmp(curr_data[3], "170H ~ 177H, 376H, 377H") == 0)
      strcpy(curr_data[3], "1F0H ~ 1F7H, 3F6H, 3F7H");
   else
      strcpy(curr_data[3], "170H ~ 177H, 376H, 377H");
   gotoxy(50,9);
   printf(curr_data[3]);
}
/**********************/
/*	change_COM1()  */
/**********************/
change_COM1()
{
   if (strcmp(curr_data[4], "disable") == 0)
      strcpy(curr_data[4], "enable ");
   else
      strcpy(curr_data[4], "disable");
   gotoxy(20,12);
   printf(curr_data[4]);
}
/**********************/
/*	change_COM1A() */
/**********************/
change_COM1A()
{
   if (strcmp(curr_data[5], "2E8H ~ 2EFH") == 0)
      strcpy(curr_data[5], "3E8H ~ 3EFH");
   else	if (strcmp(curr_data[5], "3E8H ~ 3EFH")	== 0)
      strcpy(curr_data[5], "3F8H ~ 3FFH");
   else
      strcpy(curr_data[5], "2E8H ~ 2EFH");
   gotoxy(50,12);
   printf(curr_data[5]);
}
/**********************/
/*	change_COM2()  */
/**********************/
change_COM2()
{
   if (strcmp(curr_data[6], "disable") == 0)
      strcpy(curr_data[6], "enable ");
   else
      strcpy(curr_data[6], "disable");
   gotoxy(20,15	);
   printf(curr_data[6]);
}
/**********************/
/*	change_COM2A() */
/**********************/
change_COM2A()
{
   if (strcmp(curr_data[7], "3E8H ~ 3EFH") == 0)
      strcpy(curr_data[7], "2E8H ~ 2EFH");
   else	if (strcmp(curr_data[7], "2E8H ~ 2EFH")	== 0)
      strcpy(curr_data[7], "2F8H ~ 2FFH");
   else
      strcpy(curr_data[7], "3E8H ~ 3EFH");
   gotoxy(50,15	);
   printf(curr_data[7]);
}
/**********************/
/*	change_printer()  */
/**********************/
change_printer()
{
   if (strcmp(curr_data[8], "disable") == 0)
      strcpy(curr_data[8], "enable ");
   else
      strcpy(curr_data[8], "disable");
   gotoxy(20,18);
   printf(curr_data[8]);
}
/**********************/
/*	change_printera() */
/**********************/
change_printera()
{
   if (strcmp(curr_data[9], "3BCH ~ 3BFH") == 0)
      strcpy(curr_data[9], "278H ~ 27FH");
   else	if (strcmp(curr_data[9], "278H ~ 27FH")	== 0)
      strcpy(curr_data[9], "378H ~ 37FH");
   else
      strcpy(curr_data[9], "3BCH ~ 3BFH");
   gotoxy(50,18);
   printf(curr_data[9]);
}
/**********************/
/*  change_DE()	      */
/**********************/
change_DE()
{
   if (strcmp(curr_data[10], "normal          ") == 0)
      strcpy(curr_data[10], "A <-> B exchange");
   else
      strcpy(curr_data[10], "normal          ");
   gotoxy(30,21);
   printf(curr_data[10]);
}
/***************************************************************/
/*	Function:	set_highlight()				*/
/***************************************************************/
set_highlight_up(dummy,	count)
int *count, *dummy;
{
   switch (*count)
   {
      case 1:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(50,6);
	   cputs(curr_data[1]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy (20,6);
	   cputs(curr_data[0]);
	   *dummy = getch();
	   break;
      case 2:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(20,9);
	   cputs(curr_data[2]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy(50, 6);
	   cputs(curr_data[1]);
	   *dummy = getch();
	   break;
      case 3:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(50,9);
	   cputs(curr_data[3]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy(20, 9);
	   cputs(curr_data[2]);
	   *dummy = getch();
	   break;
      case 4:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(20,12);
	   cputs(curr_data[4]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy(50, 9);
	   cputs(curr_data[3]);
	   *dummy = getch();
	   break;
      case 5:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(50,12);
	   cputs(curr_data[5]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy(20, 12);
	   cputs(curr_data[4]);
	   *dummy = getch();
	   break;
      case 6:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(20,15	);
	   cputs(curr_data[6]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy(50, 12);
	   cputs(curr_data[5]);
	   *dummy = getch();
	   break;
      case 7:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(50,15	);
	   cputs(curr_data[7]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy(20, 15 );
	   cputs(curr_data[6]);
	   *dummy = getch();
	   break;
      case 8:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(20,18);
	   cputs(curr_data[8]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy(50, 15 );
	   cputs(curr_data[7]);
	   *dummy = getch();
	   break;
      case 9:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(50,18);
	   cputs(curr_data[9]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy(20, 18);
	   cputs(curr_data[8]);
	   *dummy = getch();
	   break;
      case 10:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(30,21);
	   cputs(curr_data[10]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy(50, 18);
	   cputs(curr_data[9]);
	   *dummy = getch();
	   break;
      case 11:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(20, 6);
	   cputs(curr_data[0]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	    gotoxy(30, 21);
	    cputs(curr_data[10]);
	    *dummy = getch();
	    break;
      default:
	    printf("\007");
	    *count = 1;
	    *dummy = getch();
	    break;
   }
}
/***************************************************************/
/*	Function:	set_highlight()				*/
/***************************************************************/
set_highlight_down(dummy, count)
int *count, *dummy;
{
   switch (*count)
   {
      case 1:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(30,21);
	   cputs(curr_data[10]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy (20,6);
	   cputs(curr_data[0]);
	   *dummy = getch();
	   break;
      case 2:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(20,6);
	   cputs(curr_data[0]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy(50, 6);
	   cputs(curr_data[1]);
	   *dummy = getch();
	   break;
      case 3:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(50,6);
	   cputs(curr_data[1]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy(20, 9);
	   cputs(curr_data[2]);
	   *dummy = getch();
	   break;
      case 4:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(20,9);
	   cputs(curr_data[2]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy(50, 9);
	   cputs(curr_data[3]);
	   *dummy = getch();
	   break;
      case 5:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(50,9);
	   cputs(curr_data[3]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy(20, 12);
	   cputs(curr_data[4]);
	   *dummy = getch();
	   break;
      case 6:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(20,12);
	   cputs(curr_data[4]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy(50, 12);
	   cputs(curr_data[5]);
	   *dummy = getch();
	   break;
      case 7:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(50,12);
	   cputs(curr_data[5]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy(20, 15 );
	   cputs(curr_data[6]);
	   *dummy = getch();
	   break;
      case 8:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(20,15	);
	   cputs(curr_data[6]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy(50, 15 );
	   cputs(curr_data[7]);
	   *dummy = getch();
	   break;
      case 9:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(50,15	);
	   cputs(curr_data[7]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy(20, 18);
	   cputs(curr_data[8]);
	   *dummy = getch();
	   break;
      case 10:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(20,18);
	   cputs(curr_data[8]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy(50, 18);
	   cputs(curr_data[9]);
	   *dummy = getch();
	   break;
      case 11:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(50,18);
	   cputs(curr_data[9]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	   gotoxy(30, 21);
	   cputs(curr_data[10]);
	   *dummy = getch();
	   break;
      case 12:
	   textbackground(BLUE);
	   textcolor(WHITE);
	   gotoxy(30,21);
	   cputs(curr_data[10]);
	   textbackground(BLACK);
	   textcolor(WHITE);
	    gotoxy(20, 3 );
	    cputs(curr_data[0]);
	    *dummy = getch();
	    break;
      default:
	    printf("\007");
	    *count = 12;
	    *dummy = getch();
	    break;
   }
}

/************************************************************************/
/*	Function:	setup_window					*/
/************************************************************************/

setup_window()
{

   textbackground(BLUE);
   textcolor(WHITE);
   gotoxy (40, 6);
   cputs ("Address :");
   if( FDCE == 1 )
   {
       gotoxy(20, 6);
       cputs ("disable");
       strcpy(curr_data[0], "disable");
   }
   else
   {
      gotoxy(20, 6);
      cputs("enable");
      strcpy (curr_data[0], "enable ");
   gotoxy (50, 6);
   switch (FDCS)
   {
	 case 0	:
		cputs("370H ~ 377H");
		strcpy(curr_data[1],"370H ~ 377H");
	       break;
	 case 1	:
		cputs("3F0H ~ 3F7H");
		strcpy(curr_data[1], "3F0H ~ 3F7H");
	       break;
   }
   }
   gotoxy (40, 9);
   cputs ("Address :");
   if (IDEE == 1)
   {
      gotoxy(20, 9);
      cputs ("disable");
      strcpy (curr_data[2], "disable");
   }
   else
   {
      gotoxy(20, 9);
      cputs ("enable");
      strcpy (curr_data[2], "enable ");
   gotoxy (50, 9);
   switch (IDES)
   {
	 case 0	:
	       cputs("170H ~ 177H, 376H, 377H");
	       strcpy (curr_data[3], "170H ~ 177H, 376H, 377H");
	       break;
	 case 1	:
		cputs("1F0H ~ 1F7H, 3F6H, 3F7H");
		strcpy (curr_data[3], "1F0H ~ 1F7H, 3F6H, 3F7H");
	       break;
   }
   }
   if( COM1S ==3 )
   {
       gotoxy(20, 12);
       cputs("disable");
       strcpy (curr_data[4], "disable");
   }
   else
   {
      gotoxy(20, 12);
      cputs("enable");
      strcpy (curr_data[4], "enable ");
   }
   gotoxy (40, 12);
   cputs("Address :");
   gotoxy (50, 12);
   switch (COM1S)
   {
	 case 0	:
	    cputs( "2E8H ~ 2EFH" );
	    strcpy (curr_data[5], "2E8H ~ 2EFH"	);
	    break;
	 case 1	:
	    cputs( "3E8H ~ 3EFH" );
	    strcpy (curr_data[5], "3E8H ~ 3EFH"	);
	    break;
	 case 2	:
	    cputs( "3F8H ~ 3FFH" );
	    strcpy (curr_data[5], "3F8H ~ 3FFH"	);
	    break;
   }
   if( COM2S ==3 )
   {
       gotoxy(20, 15 );
       cputs("disable");
       strcpy (curr_data[6], "disable");
   }
   else
   {
      gotoxy(20, 15 );
      cputs("enable");
      strcpy (curr_data[6], "enable ");
   }
   gotoxy (40, 15 );
   cputs("Address :");
   gotoxy (50, 15 );
   switch (COM2S)
   {
	 case 0	:
	    cputs( "3E8H ~ 3EFH" );
	    strcpy (curr_data[7], "3E8H ~ 3EFH"	);
	    break;
	 case 1	:
	    cputs( "2E8H ~ 2EFH" );
	    strcpy (curr_data[7], "2E8H ~ 2EFH"	);
	    break;
	 case 2	:
	    cputs( "2F8H ~ 2FFH" );
	    strcpy (curr_data[7], "2F8H ~ 2FFH"	);
	    break;
   }
   if( PRT2S ==	3 )
   {
       gotoxy(20, 18);
       cputs("disable");
       strcpy (curr_data[8], "disable");
   }
   else
   {
      gotoxy(20, 18);
      cputs("enable");
      strcpy (curr_data[8], "enable ");
   }
   gotoxy (40, 18);
   cputs("Address :");
   gotoxy (50, 18);
   switch (PRT2S)
   {
	 case 0	:
	    cputs( "3BCH ~ 3BFH" );
	    strcpy (curr_data[9], "3BCH ~ 3BFH"	);
	    break;
	 case 1	:
	    cputs( "278H ~ 27FH" );
	    strcpy (curr_data[9], "278H ~ 27FH"	);
	    break;
	 case 2	:
	    cputs( "378H ~ 37FH" );
	    strcpy (curr_data[9], "378H ~ 37FH"	);
	    break;
   }

   switch (ABCG)
   {
       case 0 :
	    gotoxy(30,21);
	    cputs ( "normal " );
	    strcpy (curr_data[10], "normal          ");
	    break;
       case 1 :
	    gotoxy(30,21);
	    cputs ( "A <-> B exchange" );
	    strcpy (curr_data[10], "A <-> B exchange" );
	    break;
   }
}
/************************************************************************/
/*	Function:	textbox						*/
/************************************************************************/

textbox	(left, top, right, bottom, style)
int left, top, right, bottom, style;
{
   int r, c;
   static bord[][6] = {{196, 179, 218, 191, 217, 192},
		       {205, 186, 201, 187, 188, 200}};

   textcolor (YELLOW);
   for (c = left; c < right; c++)
   {
      gotoxy (c, top);
      cprintf ("%c", bord [style][0]);
      gotoxy (c, bottom);
      cprintf ("%c", bord [style][0]);
   }
   for (r = top; r < bottom; r++)
   {
      gotoxy (left, r);
      cprintf ("%c", bord [style][1]);
      gotoxy (right, r);
      cprintf ("%c", bord [style][1]);
   }

   gotoxy (left, top);
   cprintf ("%c", bord [style][2]);
   gotoxy (right, top);
   cprintf ("%c", bord [style][3]);
   gotoxy (right, bottom);
   cprintf ("%c", bord [style][4]);
   gotoxy (left, bottom);
   cprintf ("%c", bord [style][5]);
   for(r=2; r<24; r++ )
   {
   gotoxy(2,r);
   cprintf("                                       ");
   cprintf("                                       ");
   }
   textcolor (BOXFORE);
}
/************************************************************************/
/*	Function:	readreg						*/
/************************************************************************/

readreg()
{
   int temp[10];

   outportb(0x250,0x89); /* enable W83757A */
   outportb(0x251,0x00);
   reg0	= inport(0x252);

   IPD	= reg0 & 1;
   APD	= (reg0	>> 1) &	1;
   MOD0	= (reg0	>> 2) &	1;
   MOD1	= (reg0	>> 3) &	1;
   FDCS	= (reg0	>> 4) &	1;
   FDCE	= (reg0	>> 5) &	1;
   IDES	= (reg0	>> 6) &	1;
   IDEE	= (reg0	>> 7) &	1;

   outportb(0x251,0x01);
   reg1=inport(0x252);

   NS1	= reg1 & 1;
   NS2	= (reg1	>> 1) &	1;
   NS3	= (reg1	>> 2) &	1;
   NS4	= (reg1	>> 3) &	1;
   NP1	= (reg1	>> 4) &	1;
   NP2	= (reg1	>> 5) &	1;
   UPSA	= (reg1	>> 6) &	1;
   ABCG	= (reg1	>> 7) &	1;

   outportb(0x251,0x02);
   reg2=inport(0x252);

   CEA	   = reg2 & 1;
   temp[0] = 0;
   temp[1] = (reg2 >> 1) & 1;
   temp[2] = (reg2 >> 2) & 1;
   temp[3] = (reg2 >> 3) & 1;
   temp[4] = (reg2 >> 4) & 1;
   temp[5] = (reg2 >> 5) & 1;
   temp[6] = (reg2 >> 6) & 1;
   temp[7] = (reg2 >> 7) & 1;
   binary_to_hex(temp);
   gotoxy (5, 6);

}
/**********************/
/*   binary_to_hex()   */
/**********************/
binary_to_hex(temp)
int temp[];
{
   int tt;

   tt =	temp[7]	* 2 + temp[6];
   EAA[0] = tt + 48;
   tt =	temp[5]	* 8 + temp[4] *	4 + temp[3] * 2	+ temp[2];
   if (0 <= tt && tt <=	9)
      EAA[1] = tt + 48;
   else	if (tt == 10)
      EAA[1] = 'A';
   else	if (tt == 11)
      EAA[1] = 'B';
   else	if (tt == 12)
      EAA[1] = 'C';
   else	if (tt == 13)
      EAA[1] = 'D';
   else	if (tt == 14)
      EAA[1] = 'E';
   else	if (tt == 15)
      EAA[1] = 'F';
   else
      printf("EAA[1] is not a reason value!\n");
   if (temp[1] == 1)
   {
      EAA[2] = '8';
      EAA[3] = 'H';
   }
   else
   {
      EAA[2] = '0';
      EAA[3] = 'H';
   }
   EAA[4] = '\0';
}
/*********************/
/*   save_result()   */
/*********************/
save_result()
{
   FILE	*out;
   unsigned char result1[3], result2[3], result3[3];
   int tt, tt1;
   int temp[8];


  out =	fopen( "w757A.dat", "w+");

      tt=0;
   if (strcmp(curr_data[2], "disable") == 0)
      tt = 128;
   else
      tt = 0;
   if (strcmp(curr_data[3], "1F0H ~ 1F7H, 3F6H, 3F7H") == 0)
      tt = tt +	64 ;
   if (strcmp(curr_data[0], "disable") == 0)
      tt = tt +	32;
   if (strcmp(curr_data[1], "3F0H ~ 3F7H") == 0)
      tt = tt +	16;
   if (strcmp(curr_data[13], "printer          ") == 0)
      tt = tt +	0;
   else	if (strcmp(curr_data[13], "extension FDD    ") == 0)
      tt = tt +	4;
   else	if (strcmp(curr_data[13], "extension adapter") == 0)
      tt = tt +	8;
   if (strcmp(curr_data[12], "power on                        ") == 0)
      tt = tt +	0;
   else	if (strcmp(curr_data[12], "immediately power down          ") == 0)
      tt = tt +	1;
   else	if (strcmp(curr_data[12], "automatically power down        ") == 0)
      tt = tt +	2;
   else	if (strcmp(curr_data[12], "already automatically power down") == 0)
      tt = tt +	3;

   outportb(0x250,0x89); /* enable W83757A */
   outportb(0x251,0x00);
   outport(0x252,tt);
   fputc(tt, out);

      tt=0;
   if (strcmp(curr_data[10], "A <-> B exchange") == 0)
      tt = 128;
   else
      tt = 0;
   if (strcmp(curr_data[11], "240H") ==	0)
      tt = tt +	64;
   if (strcmp(curr_data[8], "disable") == 0)
      tt = tt +	48;
   else	if (strcmp(curr_data[9], "3BCH ~ 3BFH")	== 0)
      tt = tt +	0;
   else	if (strcmp(curr_data[9], "278H ~ 27FH")	== 0)
      tt = tt +16;
   else	if (strcmp(curr_data[9], "378H ~ 37FH")	== 0)
      tt = tt +32;
   if (strcmp(curr_data[6], "disable") == 0)
      tt = tt+10;
   else	if (strcmp(curr_data[7], "3E8H ~ 3EFH")	== 0)
      tt = tt+0;
   else	if (strcmp(curr_data[7], "2E8H ~ 2EFH")	== 0)
      tt = tt+2;
   else	if (strcmp(curr_data[7], "2F8H ~ 2FFH")	== 0)
      tt = tt+8;
   if (strcmp(curr_data[4], "disable") == 0)
      tt = tt +	5;
   else	if (strcmp(curr_data[5], "2E8H ~ 2EFH")	== 0)
      tt = tt +	0;
   else	if (strcmp(curr_data[5], "3E8H ~ 3EFH")	== 0)
      tt = tt +	1;
   else	if (strcmp(curr_data[5], "3F8H ~ 3FFH")	== 0)
      tt = tt +	4;

   outportb(0x251,0x01);
   outport(0x252,tt);
   fputc(tt, out);

      tt=0;
   if (curr_data[14][0]	== '0')
      tt = 0;
   else	if (curr_data[14][0] ==	'1')
      tt = tt+64;
   else	if (curr_data[14][0] ==	'2')
      tt = tt+128;
   else	if (curr_data[14][0] ==	'3')
      tt = tt+192;
   if (curr_data[14][1]	== '0')
      tt = tt+0;
   else	if (curr_data[14][1] ==	'1')
      tt = tt+4;
   else	if (curr_data[14][1] ==	'2')
      tt = tt+8;
   else	if (curr_data[14][1] ==	'3')
      tt = tt+12;
   else	if (curr_data[14][1] ==	'4')
      tt = tt+16;
   else	if (curr_data[14][1] ==	'5')
      tt = tt+20;
   else	if (curr_data[14][1] ==	'6')
      tt = tt+24;
   else	if (curr_data[14][1] ==	'7')
      tt = tt+28;
   else	if (curr_data[14][1] ==	'8')
      tt = tt+32;
   else	if (curr_data[14][1] ==	'9')
      tt = tt+36;
   else	if (curr_data[14][1] ==	'A' || curr_data[14][1]	== 'a')
      tt = tt+40;
   else	if (curr_data[14][1] ==	'B' || curr_data[14][1]	== 'b')
      tt = tt+44;
   else	if (curr_data[14][1] ==	'C'|| curr_data[14][1] == 'c')
      tt = tt+48;
   else	if (curr_data[14][1] ==	'D'|| curr_data[14][1] == 'd')
      tt = tt+52;
   else	if (curr_data[14][1] ==	'E'|| curr_data[14][1] == 'e')
      tt = tt+56;
   else	if (curr_data[14][1] ==	'F' || curr_data[14][1]	== 'f')
      tt = tt+60;

   if (curr_data[14][2]	== '8')
      tt = tt+2;

   if (strcmp(curr_data[15], "NO ") == 0)
      tt = tt +	1;

   outportb(0x251,0x02);
   outport(0x252, tt);
   fputc(tt, out);
   outport(0x250, 0x0);
   fclose(out);
}

set757A()
{
   FILE	*in;
   int tt;


  in =	fopen( "w757A.dat", "r+");
  if(( in= fopen("w757A.dat", "r+")) ==NULL)
  {
   cputs("\n Can't find W757A.dat file.\n");
   return(1);
  }

  tt=fgetc(in);

   outportb(0x250,0x89); /* enable W83757A */
   outportb(0x251,0x00);
   outport(0x252,tt);

  tt=fgetc(in);
   outportb(0x251,0x01);
   outport(0x252,tt);

  tt=fgetc(in);
   outportb(0x251,0x02);
   outport(0x252, tt);

   outport(0x250, 0x0);
   cputs("\n The registers of W83757A are set as W757A.dat ! \n");
   fclose(in);
}






